package beans.accountpay;

import beans.parameter.Parameter;
import common.BaseClass;
import common.Controller;
import common.YosException;
import common.data.QuerySQL;
import common.data.SQLFactory;
import common.data.db.DBConnect;

public class AccountPay {

    public static boolean isNeedPay(Controller controller, String systemappid) throws YosException {
        String siteid = controller.siteid;
        int usertype = controller.usertype;
        DBConnect dbConnect = controller.dbConnect;
        long userid = controller.userid;
        long sys_enterpriseid = controller.sys_enterpriseid;

        boolean sys_payswitch = Parameter.get(siteid, "sys_payswitch").equals("1") || Parameter.get(siteid, "sys_payswitch").equals("true");
        if (!sys_payswitch) {
            return false;
        }
        int sys_payincidence = Integer.parseInt(Parameter.get(siteid, "sys_payincidence"));

        if (usertype == 21 || usertype == 22) {
            //判断是否在试用期
            if (dbConnect.runSqlQuery(" SELECT 1 from sys_usertrialperiod WHERE siteid='" + siteid + "' and userid='" + userid + "' and CURRENT_DATE <enddate ").isNotEmpty()) {
                return false;
            }
            //判断应用是否有设置付费版本
            if (dbConnect.runSqlQuery("SELECT 1 from sys_site_systempartition WHERE siteid='" + siteid + "' and JSON_CONTAINS(systemappids, '" + systemappid + "') ").isEmpty()) {
                return false;
            }

            //查询主账号是否有付费记录
            if (sys_payincidence == 1 && usertype == 22) {

                QuerySQL querySQL = SQLFactory.createQuerySQL(dbConnect, "sys_payorderitems", "sys_payorderitemsid").setSiteid(siteid);
                querySQL.addJoinTable(BaseClass.JOINTYPE.inner, "sys_payorder", "sys_payorder", "sys_payorderid=:sys_payorderid and siteid=:siteid");
                querySQL.addJoinTable(BaseClass.JOINTYPE.inner, "sys_site_systempartition", "sys_site_systempartition", "sys_site_systempartition.sys_site_systempartitionid = sys_payorder.sys_site_systempartitionid and sys_site_systempartition.siteid = sys_payorder.siteid");

                querySQL.setWhere("CURRENT_DATE <= sys_payorderitems.enddate and sys_payorder.ispaid = 1  and sys_payorder.deleted = 0 and JSON_CONTAINS(sys_site_systempartition.systemappids, '" + systemappid + "')");
                querySQL.setWhere("sys_payorderitems.userid in (SELECT userid from sys_enterprise_hr WHERE sys_enterpriseid=" + sys_enterpriseid + " and isleader=1)");
                if (querySQL.query().isEmpty()) {
                    return true;
                }
            }

            QuerySQL querySQL = SQLFactory.createQuerySQL(dbConnect, "sys_payorderitems", "sys_payorderitemsid").setSiteid(siteid);
            querySQL.addJoinTable(BaseClass.JOINTYPE.inner, "sys_payorder", "sys_payorder", "sys_payorderid=:sys_payorderid and siteid=:siteid");
            querySQL.addJoinTable(BaseClass.JOINTYPE.inner, "sys_site_systempartition", "sys_site_systempartition", "sys_site_systempartition.sys_site_systempartitionid = sys_payorder.sys_site_systempartitionid and sys_site_systempartition.siteid = sys_payorder.siteid");

            querySQL.setWhere("CURRENT_DATE <= sys_payorderitems.enddate and sys_payorder.ispaid = 1  and sys_payorder.deleted = 0 and JSON_CONTAINS(sys_site_systempartition.systemappids, '" + systemappid + "')");

            if (sys_payincidence == 1) {
                querySQL.setWhere("sys_payorderitems.userid=" + userid);
            } else if (sys_payincidence == 2) {
                querySQL.setWhere("sys_payorderitems.sys_enterpriseid=" + sys_enterpriseid);
            }
            return querySQL.query().isEmpty();
        } else {
            return false;
        }
    }
}
