package objectregister;

import common.YosException;
import common.data.db.initialization.base.YosObject;
import common.data.db.initialization.base.YosObjectCol;

import java.util.ArrayList;

public class sys_systemapp_tablecols implements YosObject {
    @Override
    public String table_comment() {
        return "系统应用列表栏位设置表";
    }

    @Override
    public UniqueCol uniquecolumn() {
        return new UniqueCol("tablecolid", "数据ID");
    }

    @Override
    public ArrayList<YosObjectCol> table_cols() {
        ArrayList<YosObjectCol> arrayList = new ArrayList<>();
        arrayList.add(new VarcharCol("freezetype", "冻结方式", 50));//left,right
        arrayList.add(new VarcharCol("align", "对齐方式", "对齐方式", 20, "left"));//left、center、right
        arrayList.add(new LongTextCol("script", "执行脚本"));
        arrayList.add(new JsonCol("dataformat", "数据转换"));
        arrayList.add(new SmallIntCol("editable", "可编辑", 0));
        return arrayList;
    }

    @Override
    public void DataInit() throws YosException {

    }
}
