package objectregister;

import common.YosException;
import common.data.db.initialization.base.YosObject;
import common.data.db.initialization.base.YosObjectCol;

import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;

public final class sys_wechatapp implements YosObject {
    @Override
    public String table_comment() {
        return "微信应用注册";
    }

    @Override
    public YosObject.UniqueCol uniquecolumn() {
        return new UniqueCol("wechatappid", "数据ID");
    }

    @Override
    public ArrayList<YosObjectCol> table_cols() {
        ArrayList<YosObjectCol> arrayList = new ArrayList<>();
        arrayList.add(new JsonCol("pages", "微信页面列表", ""));
        arrayList.add(new SmallIntCol("isvisitor", "是否游客小程序", "必须指定绑定站点", 0));
        arrayList.add(new VarcharCol("siteid", "站点ID", "站点ID", 50));
        arrayList.add(new BigIntCol("visitor_roleid", "游客默认角色"));
        arrayList.add(new VarcharCol("systemclient_auth", "权限操作端", "如果为空，则根据systemclient获取", 50));
        return arrayList;
    }

    @Override
    public void DataInit() throws YosException {

    }
}
