package restcontroller.sysmanage.develop.requesterrlog;

import com.alibaba.fastjson.JSONObject;
import common.Controller;
import common.YosException;
import common.annotation.API;
import common.data.QuerySQL;
import common.data.SQLFactory;
import restcontroller.R;

public class requesterrlog extends Controller {
    public requesterrlog(JSONObject content) throws YosException {
        super(content);
    }

    @API(title = "接口请求错误日志查询", apiversion = R.ID10022901.v1.class)
    public String queryerrlog() throws YosException {
        /*
         * 过滤条件设置
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("sys_requesterrlog.request like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_requesterrlog.stacktrace like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_requesterrlog.title like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_requesterrlog.message like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_requesterrlog.classname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_requesterrlog.apiid like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_users.name like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or sys_systemapp.systemappname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("apiid") && !"".equals(whereObject.getString("apiid"))) {
                where.append("and sys_requesterrlog.apiid ='").append(whereObject.getString("apiid")).append("' ");
            }
            if (whereObject.containsKey("name") && !"".equals(whereObject.getString("name"))) {
                where.append("and sys_users.name ='").append(whereObject.getString("name")).append("' ");
            }
            if (whereObject.containsKey("systemappname") && !"".equals(whereObject.getString("systemappname"))) {
                where.append("and sys_systemapp.systemappname like'%").append(whereObject.getString("systemappname")).append("%' ");
            }
        }

        QuerySQL querySQL = SQLFactory.createQuerySQL(this, "sys_requesterrlog");
        querySQL.addJoinTable(JOINTYPE.left, "sys_users", "sys_users", "userid=:userid", "name");
        querySQL.addJoinTable(JOINTYPE.left, "sys_systemapp", "sys_systemapp", "systemappid=:systemappid", "systemappname");
        querySQL.addJoinTable(JOINTYPE.left, "sys_systemmodule", "sys_systemmodule", "systemmoduleid=sys_systemapp.systemmoduleid", "systemmodulename");
        querySQL.addJoinTable(JOINTYPE.left, "sys_systemclient", "sys_systemclient", "systemclientid=sys_systemmodule.systemclientid", "systemclientname");
        querySQL.setWhere(where.toString());
        querySQL.setOrderBy("sys_requesterrlogid desc");
        querySQL.setPage(pageSize, pageNumber);
        return getSucReturnObject().setData(querySQL.query()).toString();
    }
}
