package restcontroller.sysmanage.develop.userauth;

import beans.accountpay.AccountPay;
import beans.user.User;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import common.Controller;
import common.YosException;
import common.YosString;
import common.annotation.API;
import common.data.*;
import restcontroller.R;

import java.util.ArrayList;

@API(title = "管理端-开发-权限管理-权限查询")
public class userauth extends Controller {
    public userauth(JSONObject content) throws YosException {
        super(content);
    }

    @API(title = "获取当前登陆角色授权信息", apiversion = R.ID10016901.v1.class)
    public String query_userauth() throws YosException {
        Rows rows = dbConnect.runSqlQuery("select systemclient_auth from sys_wechatapp where systemclient='" + systemclient + "'");
        if (rows.isNotEmpty() && !rows.get(0).getString("systemclient_auth").trim().equals("")) {
            systemclient = rows.get(0).getString("systemclient_auth");
        }

        ArrayList<String> roleFieldLimits = User.getRoleFieldLimit(this);

        if (dbConnect.runSqlQuery("select * from sys_users where sysadministrator=1 and userid=" + userid).isEmpty()) {
            /**
             * 获取角色系统授权
             */
            SQLFactory systemsql = new SQLFactory(this, "获取角色系统授权");
            systemsql.addParameter("userid", userid);
            systemsql.addParameter("siteid", siteid);
            systemsql.addParameter("systemclient", systemclient);
            Rows systemRows = dbConnect.runSqlQuery(systemsql);
            systemRows.translate_simple(languagecode, "systemname");
            for (Row row : systemRows) {
                row.put("iconurl", getSystemIconUrl(row.getLong("systemid"), "icon"));
                row.put("iconurl_mainnav", getSystemIconUrl(row.getLong("systemid"), "mainnavicon"));
            }
            /*
             * 获取角色模块授权
             */
            SQLFactory modulesql = new SQLFactory(this, "获取角色模块授权");
            modulesql.addParameter("userid", userid);
            modulesql.addParameter("siteid", siteid);
            modulesql.addParameter("systemclient", systemclient);
            Rows moduleRows = dbConnect.runSqlQuery(modulesql);
            moduleRows.translate_simple(languagecode, "systemmodulename");
            for (Row row : moduleRows) {
                row.put("iconurl", getSystemModuleIconUrl(row.getLong("systemmoduleid"), "icon"));
                row.put("iconurl_mainnav", getSystemModuleIconUrl(row.getLong("systemmoduleid"), "mainnavicon"));
                row.put("cover", getSystemModuleCoverUrl(row.getLong("systemmoduleid")));
            }
            RowsMap moduleRowsMap = moduleRows.toRowsMap("systemid");

            /*
             * 获取角色应用授权
             */
            SQLFactory appsql = new SQLFactory(this, "获取角色应用授权");
            appsql.addParameter("userid", userid);
            appsql.addParameter("siteid", siteid);
            appsql.addParameter("systemclient", systemclient);
            Rows appRows = dbConnect.runSqlQuery(appsql);
            appRows.translate_simple(languagecode, "systemappname");

            for (Row row : appRows) {
                row.put("cover", getSystemAppCoverUrl(row.getLong("systemappid")));
            }
            RowsMap appRowsMap = appRows.toRowsMap("systemmoduleid");

            /*
             * 获取角色功能授权
             */
            SQLFactory optionsql = new SQLFactory(this, "获取角色功能授权");
            optionsql.addParameter("userid", userid);
            optionsql.addParameter("siteid", siteid);
            Rows OptionRows = dbConnect.runSqlQuery(optionsql);
            OptionRows.translate_simple(languagecode, "optionname");
            RowsMap optionRowsMap = OptionRows.toRowsMap("systemappid");
            /*
             * 获取角色限制栏位
             */
//            SQLFactory hiddenfieldsql = new SQLFactory(this, "获取角色限制栏位");
//            hiddenfieldsql.addParameter("userid", userid);
//            hiddenfieldsql.addParameter("siteid", siteid);
//            RowsMap hiddenfieldRowsMap = dbConnect.runSqlQuery(hiddenfieldsql).toRowsMap("systemappid");

            /*
             * 获取应用表单配置
             */
            QuerySQL formsql = SQLFactory.createQuerySQL(this, "sys_systemapp_forms");
            formsql.setWhere("systemappid", appRows.toArrayList("systemappid"));
            Rows formrows = formsql.query();
            RowsMap formRowsMap = formrows.toRowsMap("systemappid");

            QuerySQL formcolsql = SQLFactory.createQuerySQL(this, "sys_systemapp_formcols");
            formcolsql.setWhere("formid", formrows.toArrayList("formid"));
            formcolsql.setOrderBy("sequence", "formcolid");
            Rows allformcolRows = formcolsql.query();

            RowsMap siteformcolRowsMap = dbConnect.runSqlQuery("select formcolid,title,required,hidden,span,fielddatatype from sys_systemapp_formcols_site where siteid='" + siteid + "'").toRowsMap("formcolid");

            /*
             *获取应用表单栏位事件脚本
             */
            QuerySQL sys_scriptSQl = SQLFactory.createQuerySQL(this, "sys_script", "event", "script");
            sys_scriptSQl.addQueryFields("formcolid", "ownerid");
            sys_scriptSQl.setWhere("ownertable", "sys_systemapp_formcols");
            sys_scriptSQl.setWhere("ownerid", allformcolRows.toArrayList("formcolid"));
            RowsMap sys_scriptRowsMap = sys_scriptSQl.query().toRowsMap("formcolid");

            ArrayList<Row> hiddenformcolRow = new ArrayList<>();
            for (Row allformcolRow : allformcolRows) {
                if (siteformcolRowsMap.containsKey(allformcolRow.getString("formcolid"))) {
                    Rows sitecolsRows = siteformcolRowsMap.get(allformcolRow.getString("formcolid"));
                    if (!sitecolsRows.get(0).getString("title").equals("")) {
                        allformcolRow.put("title", sitecolsRows.get(0).getString("title"));
                    }
                    if (sitecolsRows.get(0).getInteger("span") > 1) {
                        allformcolRow.put("span", sitecolsRows.get(0).getInteger("span"));
                    }
                    if (sitecolsRows.get(0).getInteger("required") == 1) {
                        allformcolRow.put("required", 1);
                    }
                    if (sitecolsRows.get(0).getInteger("hidden") == 1 || roleFieldLimits.contains(sitecolsRows.get(0).getString("fielddatatype"))) {
                        allformcolRow.put("hidden", 1);
                    }
                    if (allformcolRow.getBoolean("hidden")) {
                        hiddenformcolRow.add(allformcolRow);
                    }
                }
                Rows scriptRows = sys_scriptRowsMap.get(allformcolRow.getString("formcolid"));
                JSONObject scriptObject = new JSONObject();
                for (Row scriptRow : scriptRows) {
                    scriptObject.put(scriptRow.getString("event"), scriptRow.getString("script"));
                }
                allformcolRow.put("eventscript", scriptObject);
                allformcolRow.put("title", YosString.process(allformcolRow.getString("title")));
            }
            for (Row row : hiddenformcolRow) {
                allformcolRows.remove(row);
            }
            allformcolRows.translate_simple(languagecode, "title");

            RowsMap fromcolRowsMap = allformcolRows.toRowsMap("formid");

            /*
             * 获取应用列表配置
             */
            QuerySQL tablesql = SQLFactory.createQuerySQL(this, "sys_systemapp_tables");
            tablesql.setWhere("systemappid", appRows.toArrayList("systemappid"));
            Rows tablerows = tablesql.query().removeColumn("siteids");
            RowsMap tableRowsMap = tablerows.toRowsMap("systemappid");

            QuerySQL tablecolsql = SQLFactory.createQuerySQL(this, "sys_systemapp_tablecols");
            tablecolsql.setWhere("tableid", tablerows.toArrayList("tableid"));
            tablecolsql.setOrderBy("sequence", "tablecolid");
            Rows alltablecolRows = tablecolsql.query();
            RowsMap sitetablecolRowsMap = dbConnect.runSqlQuery("select tablecolid,title,width,hidden,fielddatatype,editable from sys_systemapp_tablecols_site where siteid='" + siteid + "'").toRowsMap("tablecolid");

            ArrayList<Row> hiddentablecolRow = new ArrayList<>();
            for (Row tablecolRow : alltablecolRows) {
                if (sitetablecolRowsMap.containsKey(tablecolRow.getString("tablecolid"))) {
                    Rows sitecolsRows = sitetablecolRowsMap.get(tablecolRow.getString("tablecolid"));
                    if (!sitecolsRows.get(0).getString("title").equals("")) {
                        tablecolRow.put("title", sitecolsRows.get(0).getString("title"));
                    }
                    if (sitecolsRows.get(0).getInteger("width") > 0) {
                        tablecolRow.put("width", sitecolsRows.get(0).getInteger("width"));
                    }
                    if (sitecolsRows.get(0).getInteger("hidden") == 1 || roleFieldLimits.contains(sitecolsRows.get(0).getString("fielddatatype"))) {
                        tablecolRow.put("hidden", 1);
                    }
                    if (sitecolsRows.get(0).getInteger("editable") == 0) {
                        tablecolRow.put("editable", 0);
                    }
                }
                if (tablecolRow.getBoolean("hidden")) {
                    hiddentablecolRow.add(tablecolRow);
                }
                tablecolRow.put("title", YosString.process(tablecolRow.getString("title")));
            }
            for (Row row : hiddentablecolRow) {
                alltablecolRows.remove(row);
            }

            alltablecolRows.translate_simple(languagecode, "title");
            RowsMap tablecolRowsMap = alltablecolRows.toRowsMap("tableid");

            /*
             * 获取应用小组件配置
             */
            SQLFactory wedgitsql = new SQLFactory(this, "获取角色应用小组件配置");
            wedgitsql.addParameter_in("systemappid", appRows.toArrayList("systemappid"));
            RowsMap wedgitRowsMap = dbConnect.runSqlQuery(wedgitsql).toRowsMap("systemappid");


            for (Row systemRow : systemRows) {
                Rows modulerows = moduleRowsMap.get(systemRow.getString("systemid"));
                for (Row moduleRow : modulerows) {
                    Rows approws = appRowsMap.get(moduleRow.getString("systemmoduleid"));
                    for (Row appRow : approws) {
                        String systemappid = appRow.getString("systemappid");

                        Rows optionRows = optionRowsMap.get(systemappid);
                        optionRows.removeColumn(new String[]{"systemappid"});

//                        Rows hiddenfieldRows = hiddenfieldRowsMap.get(systemappid);
//                        hiddenfieldRows.removeColumn(new String[]{"systemappid"});

                        Rows wedgitsRows = wedgitRowsMap.get(systemappid);
                        wedgitsRows.removeColumn(new String[]{"systemappid"});

                        JSONObject fromObject = new JSONObject();
                        Rows formRows = formRowsMap.get(systemappid);
                        for (Row formRow : formRows) {
                            Rows formcolRows = fromcolRowsMap.get(formRow.getString("formid"));
                            formcolRows.removeColumn(new String[]{"formcolid"});
                            formRow.put("formcols", formcolRows);
                            fromObject.put(formRow.getString("form"), formRow);
                        }
                        formRows.removeColumn(new String[]{"systemappid", "form"});


                        JSONObject tableObject = new JSONObject();
                        Rows tableRows = tableRowsMap.get(systemappid);
                        for (Row tableRow : tableRows) {
                            Rows tablecolRows = tablecolRowsMap.get(tableRow.getString("tableid"));
                            tablecolRows.removeColumn(new String[]{"tablecolid"});
                            tableRow.put("tablecols", tablecolRows);
                            tableObject.put(tableRow.getString("table"), tableRow);
                        }
                        tableRows.removeColumn(new String[]{"systemappid", "table"});

                        JSONObject metaObject = new JSONObject();
                        metaObject.put("title", appRow.getString("systemappname"));
                        metaObject.put("auth", optionRows);
                        // metaObject.put("hiddenfields", hiddenfieldRows);
                        metaObject.put("wedgits", wedgitsRows);
                        metaObject.put("forms", fromObject);
                        metaObject.put("tables", tableObject);

                        appRow.put("path", appRow.getString("apppath"));
                        appRow.put("path_index", appRow.getString("apppath_index"));
                        appRow.put("name", appRow.getString("systemapp"));
                        appRow.put("meta", metaObject);
                        appRow.put("component", "");
                        appRow.put("isneedpay", AccountPay.isNeedPay(this, systemappid));
                    }
                    moduleRow.put("apps", approws);
                }
                systemRow.put("modules", modulerows);
            }
            appRows.removeColumn(new String[]{"systemappname", "systemapp", "apppath", "apppath_index"});
            return getSucReturnObject().setData(systemRows).toString();
        } else {
            /*
            系统管理员权限获取，无需授权，返回所有功能权限
             */
            /*
             * 获取角色系统授权
             */
            SQLFactory systemsql = new SQLFactory(this, "获取系统管理员角色系统授权");
            systemsql.addParameter("systemclient", systemclient);
            Rows systemRows = dbConnect.runSqlQuery(systemsql);
            systemRows.translate_simple(languagecode, "systemname");
            for (Row row : systemRows) {
                row.put("iconurl", getSystemIconUrl(row.getLong("systemid"), "icon"));
                row.put("iconurl_mainnav", getSystemIconUrl(row.getLong("systemid"), "mainnavicon"));
            }
            /*
             * 获取角色模块授权
             */
            SQLFactory modulesql = new SQLFactory(this, "获取系统管理员角色模块授权");
            modulesql.addParameter("systemclient", systemclient);
            Rows moduleRows = dbConnect.runSqlQuery(modulesql);
            moduleRows.translate_simple(languagecode, "systemmodulename");
            for (Row row : moduleRows) {
                row.put("iconurl", getSystemModuleIconUrl(row.getLong("systemmoduleid"), "icon"));
                row.put("iconurl_mainnav", getSystemModuleIconUrl(row.getLong("systemmoduleid"), "mainnavicon"));
                row.put("cover", getSystemModuleCoverUrl(row.getLong("systemmoduleid")));
            }
            RowsMap moduleRowsMap = moduleRows.toRowsMap("systemid");
            /*
             * 获取角色应用授权
             */
            SQLFactory appsql = new SQLFactory(this, "获取系统管理员角色应用授权");
            appsql.addParameter("systemclient", systemclient);
            Rows appRows = dbConnect.runSqlQuery(appsql);
            appRows.translate_simple(languagecode, "systemappname");
            for (Row row : appRows) {
                row.put("cover", getSystemAppCoverUrl(row.getLong("systemappid")));
            }
            RowsMap appRowsMap = appRows.toRowsMap("systemmoduleid");

            /*
             * 获取角色功能授权
             */
            SQLFactory optionsql = new SQLFactory(this, "获取系统管理员角色功能授权");
            optionsql.addParameter("siteid", siteid);
            Rows OptionRows = dbConnect.runSqlQuery(optionsql);
            OptionRows.translate_simple(languagecode, "optionname");
            RowsMap optionRowsMap = OptionRows.toRowsMap("systemappid");

            /*
             * 获取应用表单配置
             */
            QuerySQL formsql = SQLFactory.createQuerySQL(this, "sys_systemapp_forms");
            formsql.setWhere("systemappid", appRows.toArrayList("systemappid"));
            Rows formrows = formsql.query();
            RowsMap formRowsMap = formrows.toRowsMap("systemappid");

            QuerySQL formcolsql = SQLFactory.createQuerySQL(this, "sys_systemapp_formcols");
            formcolsql.setWhere("formid", formrows.toArrayList("formid"));
            formcolsql.setOrderBy("sequence", "formcolid");
            Rows allformcolRows = formcolsql.query();

            RowsMap siteformcolRowsMap = dbConnect.runSqlQuery("select formcolid,title,required,hidden,span,fielddatatype from sys_systemapp_formcols_site where siteid='" + siteid + "'").toRowsMap("formcolid");

            /*
             *获取应用表单栏位事件脚本
             */
            QuerySQL sys_scriptSQl = SQLFactory.createQuerySQL(this, "sys_script", "event", "script");
            sys_scriptSQl.addQueryFields("formcolid", "ownerid");
            sys_scriptSQl.setWhere("ownertable", "sys_systemapp_formcols");
            sys_scriptSQl.setWhere("ownerid", allformcolRows.toArrayList("formcolid"));
            RowsMap sys_scriptRowsMap = sys_scriptSQl.query().toRowsMap("formcolid");

            ArrayList<Row> hiddenformcolRow = new ArrayList<>();
            for (Row allformcolRow : allformcolRows) {
                if (siteformcolRowsMap.containsKey(allformcolRow.getString("formcolid"))) {
                    Rows sitecolsRows = siteformcolRowsMap.get(allformcolRow.getString("formcolid"));
                    if (!sitecolsRows.get(0).getString("title").equals("")) {
                        allformcolRow.put("title", sitecolsRows.get(0).getString("title"));
                    }
                    if (sitecolsRows.get(0).getInteger("span") > 1) {
                        allformcolRow.put("span", sitecolsRows.get(0).getInteger("span"));
                    }
                    if (sitecolsRows.get(0).getInteger("required") == 1) {
                        allformcolRow.put("required", 1);
                    }
                    if (sitecolsRows.get(0).getInteger("hidden") == 1 || roleFieldLimits.contains(sitecolsRows.get(0).getString("fielddatatype"))) {
                        allformcolRow.put("hidden", 1);
                    }
                }
                if (allformcolRow.getBoolean("hidden")) {
                    hiddenformcolRow.add(allformcolRow);
                }
                Rows scriptRows = sys_scriptRowsMap.get(allformcolRow.getString("formcolid"));
                JSONObject scriptObject = new JSONObject();
                for (Row scriptRow : scriptRows) {
                    scriptObject.put(scriptRow.getString("event"), scriptRow.getString("script"));
                }
                allformcolRow.put("eventscript", scriptObject);
                allformcolRow.put("title", YosString.process(allformcolRow.getString("title")));
            }
            for (Row row : hiddenformcolRow) {
                allformcolRows.remove(row);
            }
            allformcolRows.translate_simple(languagecode, "title");

            RowsMap fromcolRowsMap = allformcolRows.toRowsMap("formid");

            /*
             * 获取应用列表配置
             */
            QuerySQL tablesql = SQLFactory.createQuerySQL(this, "sys_systemapp_tables");
            tablesql.setWhere("systemappid", appRows.toArrayList("systemappid"));
            Rows tablerows = tablesql.query().removeColumn("siteids");
            RowsMap tableRowsMap = tablerows.toRowsMap("systemappid");

            QuerySQL tablecolsql = SQLFactory.createQuerySQL(this, "sys_systemapp_tablecols");
            tablecolsql.setWhere("tableid", tablerows.toArrayList("tableid"));
            tablecolsql.setOrderBy("sequence", "tablecolid");
            Rows alltablecolRows = tablecolsql.query();
            RowsMap sitetablecolRowsMap = dbConnect.runSqlQuery("select tablecolid,title,width,hidden,fielddatatype,editable from sys_systemapp_tablecols_site where siteid='" + siteid + "'").toRowsMap("tablecolid");

            ArrayList<Row> hiddentablecolRow = new ArrayList<>();
            for (Row tablecolRow : alltablecolRows) {
                if (sitetablecolRowsMap.containsKey(tablecolRow.getString("tablecolid"))) {
                    Rows sitecolsRows = sitetablecolRowsMap.get(tablecolRow.getString("tablecolid"));
                    if (!sitecolsRows.get(0).getString("title").equals("")) {
                        tablecolRow.put("title", sitecolsRows.get(0).getString("title"));
                    }
                    if (sitecolsRows.get(0).getInteger("width") > 0) {
                        tablecolRow.put("width", sitecolsRows.get(0).getInteger("width"));
                    }
                    if (sitecolsRows.get(0).getInteger("hidden") == 1 || roleFieldLimits.contains(sitecolsRows.get(0).getString("fielddatatype"))) {
                        tablecolRow.put("hidden", 1);
                    }
                    if (sitecolsRows.get(0).getInteger("editable") == 0) {
                        tablecolRow.put("editable", 0);
                    }
                }
                if (tablecolRow.getBoolean("hidden")) {
                    hiddentablecolRow.add(tablecolRow);
                }
                tablecolRow.put("title", YosString.process(tablecolRow.getString("title")));
            }
            for (Row row : hiddentablecolRow) {
                alltablecolRows.remove(row);
            }
            alltablecolRows.translate_simple(languagecode, "title");
            RowsMap tablecolRowsMap = alltablecolRows.toRowsMap("tableid");

            /*
             * 获取应用小组件配置
             */
            SQLFactory wedgitsql = new SQLFactory(this, "获取角色应用小组件配置");
            wedgitsql.addParameter_in("systemappid", appRows.toArrayList("systemappid"));
            RowsMap wedgitRowsMap = dbConnect.runSqlQuery(wedgitsql).toRowsMap("systemappid");


            for (Row systemRow : systemRows) {
                Rows modulerows = moduleRowsMap.get(systemRow.getString("systemid"));
                for (Row moduleRow : modulerows) {
                    Rows approws = appRowsMap.get(moduleRow.getString("systemmoduleid"));
                    for (Row appRow : approws) {
                        String systemappid = appRow.getString("systemappid");

                        Rows optionRows = optionRowsMap.get(systemappid);
                        optionRows.removeColumn(new String[]{"systemappid"});

                        Rows wedgitsRows = wedgitRowsMap.get(systemappid);
                        wedgitsRows.removeColumn(new String[]{"systemappid"});

                        JSONObject fromObject = new JSONObject();
                        Rows formRows = formRowsMap.get(systemappid);
                        for (Row formRow : formRows) {
                            Rows formcolRows = fromcolRowsMap.get(formRow.getString("formid"));
                            formcolRows.removeColumn(new String[]{"formcolid"});
                            formRow.put("formcols", formcolRows);
                            fromObject.put(formRow.getString("form"), formRow);
                        }
                        formRows.removeColumn(new String[]{"systemappid", "form"});


                        JSONObject tableObject = new JSONObject();
                        Rows tableRows = tableRowsMap.get(systemappid);
                        for (Row tableRow : tableRows) {
                            Rows tablecolRows = tablecolRowsMap.get(tableRow.getString("tableid"));
                            tablecolRows.removeColumn(new String[]{"tablecolid"});
                            tableRow.put("tablecols", tablecolRows);
                            tableObject.put(tableRow.getString("table"), tableRow);
                        }
                        tableRows.removeColumn(new String[]{"systemappid", "table"});

                        JSONObject metaObject = new JSONObject();
                        metaObject.put("title", appRow.getString("systemappname"));
                        metaObject.put("auth", optionRows);
                        metaObject.put("hiddenfields", new JSONArray());
                        metaObject.put("wedgits", wedgitsRows);
                        metaObject.put("forms", fromObject);
                        metaObject.put("tables", tableObject);

                        appRow.put("path", appRow.getString("apppath"));
                        appRow.put("path_index", appRow.getString("apppath_index"));
                        appRow.put("name", appRow.getString("systemapp"));
                        appRow.put("meta", metaObject);
                        appRow.put("component", "");
                        appRow.put("isneedpay", false);
                    }
                    moduleRow.put("apps", approws);
                }
                systemRow.put("modules", modulerows);
            }
            appRows.removeColumn(new String[]{"systemappname", "systemapp", "apppath", "apppath_index"});
            return getSucReturnObject().setData(systemRows).toString();
        }
    }

}
