package utility.kuaidi100;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;

/**
 * 免费的快递100物流查询，稳定性及准确性较差
 */
public class Kuaidi100 {
    /**
     * 物流信息查询
     *
     * @param num 快递单号
     * @return
     */
    public static JSONObject queryKuaiDi100(String num) {
        try {
            //System.setProperty("java.awt.headless", "false");
            // 1.通过快递单号获取是哪个快递公司。
            //String sdfhg = Kuaidi100.get("http://www.kuaidi100.com/?from=openv");
            // 1.通过快递单号获取是哪个快递公司。
            String typeResult = Kuaidi100.get("http://www.kuaidi100.com/autonumber/autoComNum?text=" + num);
            JSONObject typeJsonObject = JSONObject.parseObject(typeResult);
            JSONArray typeDataArray = (JSONArray) typeJsonObject.get("auto");
            if (typeDataArray.isEmpty()) {
                return null;
            }
            JSONObject typeObject = (JSONObject) typeDataArray.get(0);
            String type = typeObject.getString("comCode");
            // 2.通过快递公司及快递单号获取物流信息。
            String kuaidiResult = Kuaidi100.get("http://www.kuaidi100.com/query?type=" + type + "&postid=" + num + "&temp=0." + System.currentTimeMillis() + "&phone=");
            JSONObject jsonObject = JSONObject.parseObject(kuaidiResult);
            String status = jsonObject.getString("status");
            String nu = jsonObject.getString("nu");
            if (!"200".equals(status)) {
                return null;
            }
            //查询物流单号如果返回的物流单号不是查询的单号重新查询
            while (!num.equals(nu)) {
                // 2.通过快递公司及快递单号获取物流信息。
                kuaidiResult = Kuaidi100.get("http://www.kuaidi100.com/query?type=" + type + "&postid=" + num);
                jsonObject = JSONObject.parseObject(kuaidiResult);
                status = jsonObject.getString("status");
                nu = jsonObject.getString("nu");
                if (!"200".equals(status)) {
                    return null;
                }
            }
            return jsonObject;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    private static String get(String url) throws Exception {
        StringBuffer response = new StringBuffer();
        BufferedReader reader = null;
        HttpURLConnection conn = (HttpURLConnection) new URL(url).openConnection();
        conn.setConnectTimeout(3000);
        conn.setReadTimeout(3000);
        conn.setRequestMethod("POST");
        conn.setRequestProperty("accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8");
        conn.setRequestProperty("Upgrade-Insecure-Requests", "1");
        conn.setRequestProperty("Connection", "keep-alive");
        conn.setRequestProperty("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36");
        conn.setRequestProperty("Referer", "http://www.kuaidi100.com/?from=openv");
        conn.setRequestProperty("Host", "www.kuaidi100.com");
        //conn.setRequestProperty("Accept-Encoding", "gzip, deflate");
        conn.setRequestProperty("Accept-Language", "zh-CN,zh;q=0.9");

        conn.setDoOutput(true);
        reader = new BufferedReader(new InputStreamReader(conn.getInputStream(), StandardCharsets.UTF_8));

        String line = "";
        while ((line = reader.readLine()) != null) {
            response.append(line);
        }
        return response.toString();
    }
}