package utility.valve;

import org.apache.commons.math3.fitting.PolynomialCurveFitter;
import org.apache.commons.math3.fitting.WeightedObservedPoint;

import java.util.ArrayList;
import java.util.Collection;

public class ch1 {

    private static double getPointX(double pointY, double[] x, double[] y) {
        // 定义数据点
        // 创建加权观测点集合
        Collection<WeightedObservedPoint> obs = new ArrayList<>();
        for (int n = 0; n < x.length; n++) {
            obs.add(new WeightedObservedPoint(1, x[n], y[n]));
        }
        // 创建多项式曲线拟合器对象
        PolynomialCurveFitter fitter = PolynomialCurveFitter.create(1);
        // 拟合曲线
        double[] coefficients = fitter.fit(obs);
        return (pointY - coefficients[0]) / coefficients[1];
    }

    private static double getPointY(double pointX, double[] x, double[] y) {
        // 定义数据点
        // 创建加权观测点集合
        Collection<WeightedObservedPoint> obs = new ArrayList<>();
        for (int n = 0; n < x.length; n++) {
            obs.add(new WeightedObservedPoint(1, x[n], y[n]));
        }
        // 创建多项式曲线拟合器对象
        PolynomialCurveFitter fitter = PolynomialCurveFitter.create(1);
        // 拟合曲线
        double[] coefficients = fitter.fit(obs);
        return coefficients[0] + coefficients[1] * pointX;
    }

    public static void main(String[] args) {
        double[] LiArray = new double[]{0.0, 0.05, 0.1, 0.15, 0.18, 0.2, 0.22, 0.25, 0.28, 0.3, 0.32, 0.35, 0.4, 0.45, 0.5, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8, 0.85, 0.9, 0.95, 1.0};
        double[] KvArray = new double[]{0.0, 1265.0, 2668.0, 4063.0, 4894.0, 5450.0, 6000.0, 6810.0, 7630.0, 8160.0, 8960.0, 10150.0, 14650.0, 18720.0, 22310.0, 25420.0, 28090.0, 30350.0, 30960.0, 30960.0, 30960.0, 30960.0, 30960.0, 30960.0, 30960.0};

//        JSONArray array = new JSONArray();
//        for (int i = 0; i < LiArray.length; i++) {
//            JSONObject a = new JSONObject();
//            a.put("x", LiArray[i]);
//            a.put("y", KvArray[i]);
//            array.add(a);
//        }
//        System.err.println(array);
//
        LiArray = new double[]{0.32, 0.35};
        KvArray = new double[]{8960.0, 10150.0};

        System.err.println(ch1.getPointX(9500, LiArray, KvArray));
       // System.err.println(ch1.getPointY(0.2297611111111111, LiArray, KvArray));
    }
}
